 ! audit.br - This program creates a powerful Audit     #Autonumber# 100,10
 !  Report off of any of your BR database using the power of FileIO.
 !  Audit.br Uses FileIO and requires FileIO to run.
 !
 !  Copyright Sage AX 2010
 !
 !  Created: 5/10/2010
 !  by Gabriel Bakker
 !
 !
    if exists("runaudit.br") then
       chain "runaudit.br"
    else
       library : fnRunAudit
       let fnRunAudit
    end if
 end

 def library fnRunAudit(;Path$*255,mat Selected)
    library : fnCompare, fnBeginAudit

    if exists("auditbr\") then
       ! We've done this before. Run Both Routines.
       if fnCompare("auditbr\","auditbr.txt",1,0,Path$,mat Selected) then
          let fnBeginAudit("auditbr\",Path$,mat Selected)
       end if
    else
       ! This is the first time. So just make the backup.
       let fnBeginAudit("auditbr\",Path$,mat Selected)
    end if
 fnend

 dim AuditKeys$(1)*255

 BeginAudit: ! ***** This function will create an Audit Comparison folder for all your data files.
    def library fnBeginAudit(BackupFolder$*80;Path$*255,mat Selected,___,Index,FileName$*255,Jndex)
       if exists("fileio.br") then
          if trim$(BackupFolder$)<>"" then
             let fnLibraryLinkage
          
             let fnReadLayouts(mat FileList$)

             let fnAddTrailingSlash(BackupFolder$)
             let fnAddTrailingSlash(Path$)
             if Path$="\" then let Path$=""

             if ~exists(BackupFolder$) then execute "mkdir "&BackupFolder$

             for Index=1 to udim(Mat FileList$)
                if lwrc$(trim$(FileList$(Index)))<>"logfile" and lwrc$(trim$(FileList$(Index)))<>"activerecord1" then
                if ~sum(mat Selected) or srch(mat Selected,Index)>0 then
                   let fnReadLayoutHeader(FileList$(Index),FileName$,Mat AuditKeys$)
                   if exists(Path$&Filename$) then
                      let fnMakeSurePathExists(Path$&fileName$,BackupFolder$)
                      execute "*copy "&Path$&FileName$&" "&BackupFolder$&Path$&FileName$&" -S -N"
                      for Jndex=1 to udim(Mat AuditKeys$)
                         if exists(BackupFolder$&Path$&AuditKeys$(Jndex)) then
                            execute "*free "&BackupFolder$&Path$&AuditKeys$(Jndex)
                         end if
                      next Jndex
                   end if
                end if
                end if
             next Index
          else
             let msgbox("You must specify a Backup Folder","No Path Given")
          end if
       else
          let msgbox("FileIO is required to run Audit BR. Please install FileIO and create FileIO style Layouts.","FileIO Not Found")
       end if
    fnend

    def fnMakeSurePathExists(Filename$*255;Path$*255)
       do while pos(FileName$,"\")
          let Path$=Path$&FileName$(1:pos(FileName$,"\"))
          let FileName$=fileName$(pos(FileName$,"\")+1:len(Filename$))
          if ~Exists(Path$) then execute "mkdir "&path$
       loop
    fnend

 Compare: ! ***** This function will compare two data sets
    def library FnCompare(BackupFolder$*80;Logfile$*80,Printer,DontClose,Path$*255,mat Selected,___,Index,NewFile,OldFile,OutFile,FileName$*255)
       dim FileList$(1)*255
       dim NewF$(1)*1024,NewF(1)
       dim OldF$(1)*1024,OldF(1)
       dim CompareForm$(1)*255
       dim Records(1)

       dim Dummy$(1)*1024
       dim Dummy(1)

       if exists("fileio.br") then
          if trim$(BackupFolder$)<>"" then
             let fnAddTrailingSlash(BackupFolder$)
             let fnAddTrailingSlash(Path$)
             if Path$="\" then let Path$=""

             let fnLibraryLinkage
             let fnPrinterSys

             if len(trim$(LogFile$)) then
                open #(OutFile:=fnGetFileNumber): "name="&LogFile$&",recl=2048,use", display,output
             end if

             if Printer then
                open #255: "name=preview:/,recl=2048",display,output
                print #255: "[Landscape][A4PAPER][SetFont(Lucida Console)][CPI(15)]"
             end if

             if OutFile then print #OutFile: "File Compare started at "&Time$&" on "&Date$("month dd, ccyy")
             if Printer then print #255: "File Compare started at "&Time$&" on "&Date$("month dd, ccyy")

             if ~exists(BackupFolder$) then
                if OutFile then print #OutFile: "Backup Folder not Found."
                if Printer then print #255: "Backup Folder not Found."
             else
                let fnReadLayouts(mat FileList$)

                for Index=1 to udim(mat FileList$)
                
                   if lwrc$(trim$(FileList$(Index)))<>"logfile" and lwrc$(trim$(FileList$(Index)))<>"activerecord1" then

                   if ~sum(mat Selected) or srch(mat Selected,Index)>0 then
                      let fnReadLayoutHeader(FileList$(Index),FileName$)
                      if exists(Path$&FileName$) and exists(BackupPath$&Path$&FileName$) then

                         let NewFile=fnOpen(FileList$(Index),mat NewF$,mat NewF,mat Compareform$,1,0,0,Path$,mat Dummy$,mat Dummy,1)
                         if NewFile then
                            let OldFile=fnOpen(FileList$(Index),mat OldF$,mat OldF,mat Compareform$,1,0,0,BackupFolder$&Path$,mat Dummy$,mat Dummy,1)
                            if OldFile then

                               if OutFile then print #OutFile: "Comparing File: "&FileList$(Index)
                               if Printer then print #255: "Comparing File: "&FileList$(Index)

                               mat Records(0)=(0)
                               do until file(NewFile)=10 ! eof
                                  read #NewFile, using Compareform$(NewFile) : mat NewF$,mat NewF error Ignore
                                  if file(NewFile)=0 then
                                     Mat Records(udim(Mat Records)+1)
                                     let Records(udim(Mat Records))=rec(NewFile)

                                     read #OldFile, using Compareform$(OldFile), rec=rec(NewFile) : mat OldF$,mat OldF norec Ignore

                                     if File(OldFile) then
                                        ! Log a Record is Added message
                                        if OutFile then
                                           print #Outfile: "Record "&str$(rec(NewFile))&" was added with key: '"&fnBuildKey$(FileList$(Index),mat NewF$,mat NewF)&"', The Data was:";
                                           let fnPrintArrays$(OutFile,mat NewF$,mat NewF)
                                        end if

                                        if Printer then
                                           print #255: "[GREEN]Record "&str$(rec(NewFile))&" was added with key: '"&fnBuildKey$(FileList$(Index),mat NewF$,mat NewF)&"', The Data was:";
                                           let fnPrintArrays$(255,mat NewF$,mat NewF)
                                           print #255: "[BLACK]";
                                        end if
                                     else
                                        ! Compare two records, log both records
                                        if fnSameas(mat NewF$,mat OldF$) and fnSameA(mat NewF,mat OldF) then
                                           ! Do nothing, we're fine
                                        else
                                           if OutFile then
                                              print #Outfile: "Record "&str$(rec(NewFile))&" with key: '"&fnBuildKey$(FileList$(Index),mat NewF$,mat NewF)&"' was changed."
                                              print #OutFile: "The Data was: ";
                                              let fnPrintArrays$(OutFile,mat OldF$,mat OldF)
                                              print #OutFile: "   It is now: ";
                                              let fnPrintArrays$(Outfile,mat NewF$,mat NewF)
                                           end if

                                           if Printer then
                                              print #255: "Record "&str$(rec(NewFile))&" with key: '"&fnBuildKey$(FileList$(Index),mat NewF$,mat NewF)&"' was changed."
                                              print #255: "The Data was: ";
                                              let fnPrintArrays$(255,mat OldF$,mat OldF,1,mat NewF$,mat NewF,14)
                                              print #255: "   It is now: ";
                                              let fnPrintArrays$(255,mat NewF$,mat NewF,1,mat OldF$,mat OldF,14)
                                           end if
                                        end if
                                     end if
                                  else if file(newfile)<>10 then
                                     ! Log an Error Reading File message
                                     if OutFile then
                                        print #Outfile: "Warning: Error Reading Record "&str$(rec(NewFile))&" in the current data. Record Skipped."
                                     end if

                                     if Printer then
                                        print #255: "[RED]Warning: Error Reading Record "&str$(rec(NewFile))&" in the current data. Record Skipped.[BLACK]"
                                     end if
                                  end if
                               loop
                               restore #OldFile:
                               do until file(OldFile)=10 ! Eof
                                  read #OldFile, using CompareForm$(OldFile) : mat OldF$,mat OldF error Ignore
                                  if file(OldFile)=0 then
                                     if srch(Records,rec(OldFile))<1 then
                                        if OutFile then
                                           print #Outfile: "Record "&str$(rec(OldFile))&" was deleted with key: '"&fnBuildKey$(FileList$(Index),mat OldF$,mat OldF)&"', The Data was:"
                                           let fnPrintArrays$(OutFile,mat OldF$,mat OldF)
                                        end if
                                        if Printer then
                                           print #255: "[RED]Record "&str$(rec(OldFile))&" was deleted with key: '"&fnBuildKey$(FileList$(Index),mat OldF$,mat OldF)&"', The Data was:"
                                           let fnPrintArrays$(255,mat OldF$,mat OldF)
                                           print #255: "[BLACK]";
                                        end if
                                     end if
                                  else if file(OldFile)<>10 then
                                     ! Log an Error Reading File message
                                     if OutFile then
                                        print #Outfile: "Warning: Error Reading Record "&str$(rec(OldFile))&" in the history data. Record Skipped."
                                     end if

                                     if Printer then
                                        print #255: "[RED]Warning: Error Reading Record "&str$(rec(OldFile))&" in the history data. Record Skipped.[BLACK]"
                                     end if
                                  end if
                               loop

                               Close #OldFile:
                            end if
                            Close #NewFile:
                         end if
                      end if
                   end if
                   end if
                next Index
             end if

             if OutFile then Close #OutFile:
             if Printer and ~DontClose then Close #255:

             let fnCompare=1
          else
             let msgbox("You must specify a Backup Folder","No Path Given")
          end if
       else
          let msgbox("FileIO is required to run Audit BR. Please install FileIO and create FileIO style Layouts.","FileIO Not Found")
       end if
    fnend

    def fnPrintArrays$(FileNumber,mat F$,mat F;Color,mat Of$,mat Of,Length,___,Index)
       for Index=1 to udim(mat F$)
          let Length+=len(f$(Index))+2
          if Length>120 and FileNumber=255 then print #FileNumber: : let Length=0
          if Color and trim$(Of$(Index))<>trim$(F$(Index)) then
             print #FileNumber: "[Red]"&trim$(F$(Index))&", "&"[Black]";
          else
             print #FileNumber: trim$(F$(Index))&", ";
          end if
       next Index
       for Index=1 to udim(mat F)
          let Length+=len(str$(f(Index)))+2
          if Length>128 and FileNumber=255 then print #FileNumber: : let Length=0
          if Color and Of(Index)<>F(Index) then
             print #FileNumber: "[Red]"&str$(F(Index))&", "&"[Black]";
          else
             print #FileNumber: str$(F(Index))&", ";
          end if
       next Index
       print #Filenumber:
    fnend

    dim PrinterSysSet
    def fnPrinterSys ! Activate Printer.Sys commands
       if ~PrinterSysSet then
          execute "config PRINTER TYPE NWP select WIN:"
          execute "config PRINTER TYPE NWP select PREVIEW:"

          execute 'config PRINTER NWP [RED], "\Ecolor=''#FF0000''"'
          execute 'config PRINTER NWP [GREEN], "\Ecolor=''#00FF00''"'
          execute 'config PRINTER NWP [BLACK], "\Ecolor=''#000000''"'
          execute 'config PRINTER NWP [CPI(NNN)], "\E(sNNNH"'
          execute 'config PRINTER NWP [SETFONT(FontName)], "\Efont=''FontName''"'
          execute 'config PRINTER NWP [A4PAPER], "\E&l26A" ! 210mm x 297mm'
          execute 'config PRINTER NWP [LANDSCAPE], "\E&l1O"'
          let PrinterSysSet=1
       end if
    fnend

 SAMEAS: !   ***** Compares Two String Arrays Returning True If Same
    def Fnsameas(Mat A$,Mat B$;___,Failed,Index)
       if Udim(Mat A$)=Udim(Mat B$) then
          for Index=1 to Udim(Mat A$)
             if Trim$(A$(Index))<>Trim$(B$(Index)) then let Failed=1
          next Index
          let Fnsameas=(~(Failed))
       end if
    fnend
 !
 SAMEA: !   ***** Compares  Two Number Arrays Returning True If Same
    def Fnsamea(Mat A,Mat B;___,Failed,Index)
       if Udim(Mat A)=Udim(Mat B) then
          for Index=1 to Udim(Mat A)
             if A(Index)<>B(Index) then let Failed=1
          next Index
          let Fnsamea=(~(Failed))
       end if
    fnend

    def fnAddTrailingSlash(&Folder$)
       if Folder$(len(Folder$):len(Folder$))<>"\" then
          let Folder$=Folder$&"\"
       end if
    fnend
    
    def fnLibraryLinkage
       if ~LinkageEstablished then
          library "fileio" : fnReadLayouts, fnOpenFile, fnGetFileNumber, fnBuildKey$, FnReadLayoutHeader
          let LinkageEstablished=1
       end if
    fnend

 ! #Autonumber# 99000,10
 OPEN: ! ***** Function To Call Library Openfile And Proc Subs
    def Fnopen(Filename$*255, Mat F$, Mat F, Mat Form$; Inputonly, Keynum, Dont_Sort_Subs, Path$*255, Mat Descr$, Mat Field_Widths,Supress_Prompt,___,Index)
       dim _FileIOSubs$(1)*800
       let Fnopen=Fnopenfile(Filename$, Mat F$, Mat F, Mat Form$, Inputonly, Keynum, Dont_Sort_Subs, Path$, Mat Descr$, Mat Field_Widths, Mat _FileIOSubs$, Supress_Prompt)
       for Index=1 to udim(mat _FileIOSubs$) : execute (_FileIOSubs$(Index)) : next Index
    fnend
 !
 ! #Autonumber# 99900,10
 IGNORE: continue
 RetryCount: !
    if ErrorRetryCount<5 then
       let ErrorRetryCount+=1
       retry
    else
       let ErrorRetryCount=0
       continue
    end if